---------------------------------------------------------------
-- FN1241 t[GV^f[^ԃtB^23bito͎
-- PCM1704 DAC 24bit͏o
-- f[^ϊjbg eXgx`
-- XC2C64A-7VQG44C[Xlinx]
-- In_FN1241_FO_tb.vhd
-- 11-Aug.-2009 Y.Kuroda  RATOC Systems,Inc.
-- 11-Aug.-2009 debug
-- 18-Aug.-2009 debug2 64clk
-- 19-Aug.-2009 debug3 23bit24bitŏo SDOL FCKOLt
-- 20-Aug.-2009 release
-- 29-Jun.-2022 RgC
---------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.NUMERIC_STD.ALL;

entity In_FN1241_FO_tb is
end In_FN1241_FO_tb;

architecture In_FN1241_FO_tb_arc of In_FN1241_FO_tb is

	component In_FN1241_FO
	PORT(
		SCLK_i : IN std_logic;
		SDOL : IN std_logic;
		FCKOL : IN std_logic;
		BCLK : OUT std_logic;
		WCLK : OUT std_logic;
		SDOUT : OUT std_logic;
		RESET : IN std_logic
		);
	end component;

	--Inputs
	signal SCLK :  std_logic := '0';
	signal SDOL :  std_logic := '0';
	signal FCKOL :  std_logic := '0';
	signal RESET :  std_logic := '0';

	--Outputs
	signal SDOUT :  std_logic;
	signal BCLK :  std_logic;
	signal WCLK :  std_logic;
	
	constant TIME1:time:=20 ns;
	constant TIME2:time:=40 ns;

begin

	-- Instantiate the Unit Under Test (UUT)
	uut: In_FN1241_FO port map(
		SCLK_i => SCLK,
		SDOL => SDOL,
		FCKOL => FCKOL,
		BCLK => BCLK,
		WCLK => WCLK,
		SDOUT => SDOUT,
		RESET => RESET
	);

	SCLK_tb : process
	begin
		SCLK <='0';
		wait for TIME1;
		SCLK <='1';
		wait for TIME1;
		
	end process;

	RESET_tb : process
	begin
		RESET <='0';
		wait for TIME2;
		wait for TIME1;
		RESET <='1';
		wait;
	end process;

	FCKOL_tb : process
	begin
		FCKOL <='0';
		wait until RESET='1';
		wait for TIME2;
		for j in 0 to 6 loop
			--n
			wait until SCLK='1';		FCKOL <='1';
			wait until SCLK='1';		FCKOL <='0';
			for i in 2 to 63 loop
				wait until SCLK='1';
			end loop;
		end loop;
		wait;
	end process;

	SDOL_tb : process
	begin
		SDOL <='0';
		wait until RESET='1';
		--1 0000 0000 007F FFFFh
		wait for TIME2;
		wait until SCLK='1';		SDOL <='1';	-- 0
		wait until SCLK='1';		SDOL <='1';	-- 1
		wait until SCLK='1';		SDOL <='1';	-- 2
		wait until SCLK='1';		SDOL <='1';	-- 3
		wait until SCLK='1';		SDOL <='1';	-- 4
		wait until SCLK='1';		SDOL <='1';	-- 5
		wait until SCLK='1';		SDOL <='1';	-- 6
		wait until SCLK='1';		SDOL <='1';	-- 7
		wait until SCLK='1';		SDOL <='1';	-- 8
		wait until SCLK='1';		SDOL <='1';	-- 9
		wait until SCLK='1';		SDOL <='1';	-- 10
		wait until SCLK='1';		SDOL <='1';	-- 11
		wait until SCLK='1';		SDOL <='1';	-- 12
		wait until SCLK='1';		SDOL <='1';	-- 13
		wait until SCLK='1';		SDOL <='1';	-- 14
		wait until SCLK='1';		SDOL <='1';	-- 15
		wait until SCLK='1';		SDOL <='1';	-- 16
		wait until SCLK='1';		SDOL <='1';	-- 17
		wait until SCLK='1';		SDOL <='1';	-- 18
		wait until SCLK='1';		SDOL <='1';	-- 19
		wait until SCLK='1';		SDOL <='1';	-- 20
		wait until SCLK='1';		SDOL <='1';	-- 21
		wait until SCLK='1';		SDOL <='1';	-- 22
		wait until SCLK='1';		SDOL <='0';	-- 23
		wait until SCLK='1';		SDOL <='0';	-- 24
		wait until SCLK='1';		SDOL <='0';	-- 25
		wait until SCLK='1';		SDOL <='0';	-- 26
		wait until SCLK='1';		SDOL <='0';	-- 27
		wait until SCLK='1';		SDOL <='0';	-- 28
		wait until SCLK='1';		SDOL <='0';	-- 29
		wait until SCLK='1';		SDOL <='0';	-- 30
		wait until SCLK='1';		SDOL <='0';	-- 31
		wait until SCLK='1';		SDOL <='0';	-- 32
		wait until SCLK='1';		SDOL <='0';	-- 33
		wait until SCLK='1';		SDOL <='0';	-- 34
		wait until SCLK='1';		SDOL <='0';	-- 35
		wait until SCLK='1';		SDOL <='0';	-- 36
		wait until SCLK='1';		SDOL <='0';	-- 37
		wait until SCLK='1';		SDOL <='0';	-- 38
		wait until SCLK='1';		SDOL <='0';	-- 39
		wait until SCLK='1';		SDOL <='0';	-- 40
		wait until SCLK='1';		SDOL <='0';	-- 41
		wait until SCLK='1';		SDOL <='0';	-- 42
		wait until SCLK='1';		SDOL <='0';	-- 43
		wait until SCLK='1';		SDOL <='0';	-- 44
		wait until SCLK='1';		SDOL <='0';	-- 45
		wait until SCLK='1';		SDOL <='0';	-- 46
		wait until SCLK='1';		SDOL <='0';	-- 47
		wait until SCLK='1';		SDOL <='0';	-- 48
		wait until SCLK='1';		SDOL <='0';	-- 49
		wait until SCLK='1';		SDOL <='0';	-- 50
		wait until SCLK='1';		SDOL <='0';	-- 51
		wait until SCLK='1';		SDOL <='0';	-- 52
		wait until SCLK='1';		SDOL <='0';	-- 53
		wait until SCLK='1';		SDOL <='0';	-- 54
		wait until SCLK='1';		SDOL <='0';	-- 55
		wait until SCLK='1';		SDOL <='0';	-- 56
		wait until SCLK='1';		SDOL <='0';	-- 57
		wait until SCLK='1';		SDOL <='0';	-- 58
		wait until SCLK='1';		SDOL <='0';	-- 59
		wait until SCLK='1';		SDOL <='0';	-- 60
		wait until SCLK='1';		SDOL <='0';	-- 61
		wait until SCLK='1';		SDOL <='0';	-- 62
		wait until SCLK='1';		SDOL <='0';	-- 63
		--2 0000 0000 0055 5555h
		wait until SCLK='1';		SDOL <='1';	-- 0
		wait until SCLK='1';		SDOL <='0';	-- 1
		wait until SCLK='1';		SDOL <='1';	-- 2
		wait until SCLK='1';		SDOL <='0';	-- 3
		wait until SCLK='1';		SDOL <='1';	-- 4
		wait until SCLK='1';		SDOL <='0';	-- 5
		wait until SCLK='1';		SDOL <='1';	-- 6
		wait until SCLK='1';		SDOL <='0';	-- 7
		wait until SCLK='1';		SDOL <='1';	-- 8
		wait until SCLK='1';		SDOL <='0';	-- 9
		wait until SCLK='1';		SDOL <='1';	-- 10
		wait until SCLK='1';		SDOL <='0';	-- 11
		wait until SCLK='1';		SDOL <='1';	-- 12
		wait until SCLK='1';		SDOL <='0';	-- 13
		wait until SCLK='1';		SDOL <='1';	-- 14
		wait until SCLK='1';		SDOL <='0';	-- 15
		wait until SCLK='1';		SDOL <='1';	-- 16
		wait until SCLK='1';		SDOL <='0';	-- 17
		wait until SCLK='1';		SDOL <='1';	-- 18
		wait until SCLK='1';		SDOL <='0';	-- 19
		wait until SCLK='1';		SDOL <='1';	-- 20
		wait until SCLK='1';		SDOL <='0';	-- 21
		wait until SCLK='1';		SDOL <='1';	-- 22
		wait until SCLK='1';		SDOL <='0';	-- 23
		wait until SCLK='1';		SDOL <='0';	-- 24
		wait until SCLK='1';		SDOL <='0';	-- 25
		wait until SCLK='1';		SDOL <='0';	-- 26
		wait until SCLK='1';		SDOL <='0';	-- 27
		wait until SCLK='1';		SDOL <='0';	-- 28
		wait until SCLK='1';		SDOL <='0';	-- 29
		wait until SCLK='1';		SDOL <='0';	-- 30
		wait until SCLK='1';		SDOL <='0';	-- 31
		wait until SCLK='1';		SDOL <='0';	-- 32
		wait until SCLK='1';		SDOL <='0';	-- 33
		wait until SCLK='1';		SDOL <='0';	-- 34
		wait until SCLK='1';		SDOL <='0';	-- 35
		wait until SCLK='1';		SDOL <='0';	-- 36
		wait until SCLK='1';		SDOL <='0';	-- 37
		wait until SCLK='1';		SDOL <='0';	-- 38
		wait until SCLK='1';		SDOL <='0';	-- 39
		wait until SCLK='1';		SDOL <='0';	-- 40
		wait until SCLK='1';		SDOL <='0';	-- 41
		wait until SCLK='1';		SDOL <='0';	-- 42
		wait until SCLK='1';		SDOL <='0';	-- 43
		wait until SCLK='1';		SDOL <='0';	-- 44
		wait until SCLK='1';		SDOL <='0';	-- 45
		wait until SCLK='1';		SDOL <='0';	-- 46
		wait until SCLK='1';		SDOL <='0';	-- 47
		wait until SCLK='1';		SDOL <='0';	-- 48
		wait until SCLK='1';		SDOL <='0';	-- 49
		wait until SCLK='1';		SDOL <='0';	-- 50
		wait until SCLK='1';		SDOL <='0';	-- 51
		wait until SCLK='1';		SDOL <='0';	-- 52
		wait until SCLK='1';		SDOL <='0';	-- 53
		wait until SCLK='1';		SDOL <='0';	-- 54
		wait until SCLK='1';		SDOL <='0';	-- 55
		wait until SCLK='1';		SDOL <='0';	-- 56
		wait until SCLK='1';		SDOL <='0';	-- 57
		wait until SCLK='1';		SDOL <='0';	-- 58
		wait until SCLK='1';		SDOL <='0';	-- 59
		wait until SCLK='1';		SDOL <='0';	-- 60
		wait until SCLK='1';		SDOL <='0';	-- 61
		wait until SCLK='1';		SDOL <='0';	-- 62
		wait until SCLK='1';		SDOL <='0';	-- 63
		--3 0000 0000 002A AAAAh
		wait until SCLK='1';		SDOL <='0';	-- 0
		wait until SCLK='1';		SDOL <='1';	-- 1
		wait until SCLK='1';		SDOL <='0';	-- 2
		wait until SCLK='1';		SDOL <='1';	-- 3
		wait until SCLK='1';		SDOL <='0';	-- 4
		wait until SCLK='1';		SDOL <='1';	-- 5
		wait until SCLK='1';		SDOL <='0';	-- 6
		wait until SCLK='1';		SDOL <='1';	-- 7
		wait until SCLK='1';		SDOL <='0';	-- 8
		wait until SCLK='1';		SDOL <='1';	-- 9
		wait until SCLK='1';		SDOL <='0';	-- 10
		wait until SCLK='1';		SDOL <='1';	-- 11
		wait until SCLK='1';		SDOL <='0';	-- 12
		wait until SCLK='1';		SDOL <='1';	-- 13
		wait until SCLK='1';		SDOL <='0';	-- 14
		wait until SCLK='1';		SDOL <='1';	-- 15
		wait until SCLK='1';		SDOL <='0';	-- 16
		wait until SCLK='1';		SDOL <='1';	-- 17
		wait until SCLK='1';		SDOL <='0';	-- 18
		wait until SCLK='1';		SDOL <='1';	-- 19
		wait until SCLK='1';		SDOL <='0';	-- 20
		wait until SCLK='1';		SDOL <='1';	-- 21
		wait until SCLK='1';		SDOL <='0';	-- 22
		wait until SCLK='1';		SDOL <='0';	-- 23
		wait until SCLK='1';		SDOL <='0';	-- 24
		wait until SCLK='1';		SDOL <='0';	-- 25
		wait until SCLK='1';		SDOL <='0';	-- 26
		wait until SCLK='1';		SDOL <='0';	-- 27
		wait until SCLK='1';		SDOL <='0';	-- 28
		wait until SCLK='1';		SDOL <='0';	-- 29
		wait until SCLK='1';		SDOL <='0';	-- 30
		wait until SCLK='1';		SDOL <='0';	-- 31
		wait until SCLK='1';		SDOL <='0';	-- 32
		wait until SCLK='1';		SDOL <='0';	-- 33
		wait until SCLK='1';		SDOL <='0';	-- 34
		wait until SCLK='1';		SDOL <='0';	-- 35
		wait until SCLK='1';		SDOL <='0';	-- 36
		wait until SCLK='1';		SDOL <='0';	-- 37
		wait until SCLK='1';		SDOL <='0';	-- 38
		wait until SCLK='1';		SDOL <='0';	-- 39
		wait until SCLK='1';		SDOL <='0';	-- 40
		wait until SCLK='1';		SDOL <='0';	-- 41
		wait until SCLK='1';		SDOL <='0';	-- 42
		wait until SCLK='1';		SDOL <='0';	-- 43
		wait until SCLK='1';		SDOL <='0';	-- 44
		wait until SCLK='1';		SDOL <='0';	-- 45
		wait until SCLK='1';		SDOL <='0';	-- 46
		wait until SCLK='1';		SDOL <='0';	-- 47
		wait until SCLK='1';		SDOL <='0';	-- 48
		wait until SCLK='1';		SDOL <='0';	-- 49
		wait until SCLK='1';		SDOL <='0';	-- 50
		wait until SCLK='1';		SDOL <='0';	-- 51
		wait until SCLK='1';		SDOL <='0';	-- 52
		wait until SCLK='1';		SDOL <='0';	-- 53
		wait until SCLK='1';		SDOL <='0';	-- 54
		wait until SCLK='1';		SDOL <='0';	-- 55
		wait until SCLK='1';		SDOL <='0';	-- 56
		wait until SCLK='1';		SDOL <='0';	-- 57
		wait until SCLK='1';		SDOL <='0';	-- 58
		wait until SCLK='1';		SDOL <='0';	-- 59
		wait until SCLK='1';		SDOL <='0';	-- 60
		wait until SCLK='1';		SDOL <='0';	-- 61
		wait until SCLK='1';		SDOL <='0';	-- 62
		wait until SCLK='1';		SDOL <='0';	-- 63
		--4 0000 0000 005F FFFDh
		wait until SCLK='1';		SDOL <='1';	-- 0
		wait until SCLK='1';		SDOL <='0';	-- 1
		wait until SCLK='1';		SDOL <='1';	-- 2
		wait until SCLK='1';		SDOL <='1';	-- 3
		wait until SCLK='1';		SDOL <='1';	-- 4
		wait until SCLK='1';		SDOL <='1';	-- 5
		wait until SCLK='1';		SDOL <='1';	-- 6
		wait until SCLK='1';		SDOL <='1';	-- 7
		wait until SCLK='1';		SDOL <='1';	-- 8
		wait until SCLK='1';		SDOL <='1';	-- 9
		wait until SCLK='1';		SDOL <='1';	-- 10
		wait until SCLK='1';		SDOL <='1';	-- 11
		wait until SCLK='1';		SDOL <='1';	-- 12
		wait until SCLK='1';		SDOL <='1';	-- 13
		wait until SCLK='1';		SDOL <='1';	-- 14
		wait until SCLK='1';		SDOL <='1';	-- 15
		wait until SCLK='1';		SDOL <='1';	-- 16
		wait until SCLK='1';		SDOL <='1';	-- 17
		wait until SCLK='1';		SDOL <='1';	-- 18
		wait until SCLK='1';		SDOL <='1';	-- 19
		wait until SCLK='1';		SDOL <='1';	-- 20
		wait until SCLK='1';		SDOL <='0';	-- 21
		wait until SCLK='1';		SDOL <='1';	-- 22
		wait until SCLK='1';		SDOL <='0';	-- 23
		wait until SCLK='1';		SDOL <='0';	-- 24
		wait until SCLK='1';		SDOL <='0';	-- 25
		wait until SCLK='1';		SDOL <='0';	-- 26
		wait until SCLK='1';		SDOL <='0';	-- 27
		wait until SCLK='1';		SDOL <='0';	-- 28
		wait until SCLK='1';		SDOL <='0';	-- 29
		wait until SCLK='1';		SDOL <='0';	-- 30
		wait until SCLK='1';		SDOL <='0';	-- 31
		wait until SCLK='1';		SDOL <='0';	-- 32
		wait until SCLK='1';		SDOL <='0';	-- 33
		wait until SCLK='1';		SDOL <='0';	-- 34
		wait until SCLK='1';		SDOL <='0';	-- 35
		wait until SCLK='1';		SDOL <='0';	-- 36
		wait until SCLK='1';		SDOL <='0';	-- 37
		wait until SCLK='1';		SDOL <='0';	-- 38
		wait until SCLK='1';		SDOL <='0';	-- 39
		wait until SCLK='1';		SDOL <='0';	-- 40
		wait until SCLK='1';		SDOL <='0';	-- 41
		wait until SCLK='1';		SDOL <='0';	-- 42
		wait until SCLK='1';		SDOL <='0';	-- 43
		wait until SCLK='1';		SDOL <='0';	-- 44
		wait until SCLK='1';		SDOL <='0';	-- 45
		wait until SCLK='1';		SDOL <='0';	-- 46
		wait until SCLK='1';		SDOL <='0';	-- 47
		wait until SCLK='1';		SDOL <='0';	-- 48
		wait until SCLK='1';		SDOL <='0';	-- 49
		wait until SCLK='1';		SDOL <='0';	-- 50
		wait until SCLK='1';		SDOL <='0';	-- 51
		wait until SCLK='1';		SDOL <='0';	-- 52
		wait until SCLK='1';		SDOL <='0';	-- 53
		wait until SCLK='1';		SDOL <='0';	-- 54
		wait until SCLK='1';		SDOL <='0';	-- 55
		wait until SCLK='1';		SDOL <='0';	-- 56
		wait until SCLK='1';		SDOL <='0';	-- 57
		wait until SCLK='1';		SDOL <='0';	-- 58
		wait until SCLK='1';		SDOL <='0';	-- 59
		wait until SCLK='1';		SDOL <='0';	-- 60
		wait until SCLK='1';		SDOL <='0';	-- 61
		wait until SCLK='1';		SDOL <='0';	-- 62
		wait until SCLK='1';		SDOL <='0';	-- 63
		--5 0000 0000 0040 0001h
		wait until SCLK='1';		SDOL <='1';	-- 0
		wait until SCLK='1';		SDOL <='0';	-- 1
		wait until SCLK='1';		SDOL <='0';	-- 2
		wait until SCLK='1';		SDOL <='0';	-- 3
		wait until SCLK='1';		SDOL <='0';	-- 4
		wait until SCLK='1';		SDOL <='0';	-- 5
		wait until SCLK='1';		SDOL <='0';	-- 6
		wait until SCLK='1';		SDOL <='0';	-- 7
		wait until SCLK='1';		SDOL <='0';	-- 8
		wait until SCLK='1';		SDOL <='0';	-- 9
		wait until SCLK='1';		SDOL <='0';	-- 10
		wait until SCLK='1';		SDOL <='0';	-- 11
		wait until SCLK='1';		SDOL <='0';	-- 12
		wait until SCLK='1';		SDOL <='0';	-- 13
		wait until SCLK='1';		SDOL <='0';	-- 14
		wait until SCLK='1';		SDOL <='0';	-- 15
		wait until SCLK='1';		SDOL <='0';	-- 16
		wait until SCLK='1';		SDOL <='0';	-- 17
		wait until SCLK='1';		SDOL <='0';	-- 18
		wait until SCLK='1';		SDOL <='0';	-- 19
		wait until SCLK='1';		SDOL <='0';	-- 20
		wait until SCLK='1';		SDOL <='0';	-- 21
		wait until SCLK='1';		SDOL <='1';	-- 22
		wait until SCLK='1';		SDOL <='0';	-- 23
		wait until SCLK='1';		SDOL <='0';	-- 24
		wait until SCLK='1';		SDOL <='0';	-- 25
		wait until SCLK='1';		SDOL <='0';	-- 26
		wait until SCLK='1';		SDOL <='0';	-- 27
		wait until SCLK='1';		SDOL <='0';	-- 28
		wait until SCLK='1';		SDOL <='0';	-- 29
		wait until SCLK='1';		SDOL <='0';	-- 30
		wait until SCLK='1';		SDOL <='0';	-- 31
		wait until SCLK='1';		SDOL <='0';	-- 32
		wait until SCLK='1';		SDOL <='0';	-- 33
		wait until SCLK='1';		SDOL <='0';	-- 34
		wait until SCLK='1';		SDOL <='0';	-- 35
		wait until SCLK='1';		SDOL <='0';	-- 36
		wait until SCLK='1';		SDOL <='0';	-- 37
		wait until SCLK='1';		SDOL <='0';	-- 38
		wait until SCLK='1';		SDOL <='0';	-- 39
		wait until SCLK='1';		SDOL <='0';	-- 40
		wait until SCLK='1';		SDOL <='0';	-- 41
		wait until SCLK='1';		SDOL <='0';	-- 42
		wait until SCLK='1';		SDOL <='0';	-- 43
		wait until SCLK='1';		SDOL <='0';	-- 44
		wait until SCLK='1';		SDOL <='0';	-- 45
		wait until SCLK='1';		SDOL <='0';	-- 46
		wait until SCLK='1';		SDOL <='0';	-- 47
		wait until SCLK='1';		SDOL <='0';	-- 48
		wait until SCLK='1';		SDOL <='0';	-- 49
		wait until SCLK='1';		SDOL <='0';	-- 50
		wait until SCLK='1';		SDOL <='0';	-- 51
		wait until SCLK='1';		SDOL <='0';	-- 52
		wait until SCLK='1';		SDOL <='0';	-- 53
		wait until SCLK='1';		SDOL <='0';	-- 54
		wait until SCLK='1';		SDOL <='0';	-- 55
		wait until SCLK='1';		SDOL <='0';	-- 56
		wait until SCLK='1';		SDOL <='0';	-- 57
		wait until SCLK='1';		SDOL <='0';	-- 58
		wait until SCLK='1';		SDOL <='0';	-- 59
		wait until SCLK='1';		SDOL <='0';	-- 60
		wait until SCLK='1';		SDOL <='0';	-- 61
		wait until SCLK='1';		SDOL <='0';	-- 62
		wait until SCLK='1';		SDOL <='0';	-- 63
		
		wait until SCLK='1';		SDOL <='0';
		wait;
	end process;
end In_FN1241_FO_tb_arc;
